# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.96) ? 1 : 0);' 2>/dev/null || echo 0)

# If we're going to do the Kwalitee test, we'll need Test::Kwalitee ≥ 1.21
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
%global old_tk 0
%else
%global old_tk 1
%endif

# Pure-perl implementation requires Hash::Util::FieldHash, which requires perl ≥ 5.10
%global xsonly %(perl -e 'print $] >= 5.010 ? 0 : 1;' 2>/dev/null || echo 0)

#TODO: BR: perl(Test::Pod::No404s) when available

Name:		perl-B-Hooks-EndOfScope
Version:	0.21
Release:	2.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Summary:	Execute code after scope compilation finishes
URL:		http://search.cpan.org/dist/B-Hooks-EndOfScope/
Source0:	http://search.cpan.org/CPAN/authors/id/E/ET/ETHER/B-Hooks-EndOfScope-%{version}.tar.gz
Patch1:		B-Hooks-EndOfScope-0.21-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(base)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
BuildRequires:	perl(Text::ParseWords)
# Module
# note: Variable::Magic only needed (version ≥ 0.48) by XS version
#	Various other modules only needed by PP version
%if ! %{xsonly}
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Hash::Util::FieldHash)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(Tie::StdHash)
%endif
BuildRequires:	perl(Module::Implementation) >= 0.05
BuildRequires:	perl(strict)
BuildRequires:	perl(Sub::Exporter::Progressive) >= 0.001006
BuildRequires:	perl(Variable::Magic) >= 0.48
BuildRequires:	perl(warnings)
# Test suite
BuildRequires:	perl(Config)
BuildRequires:	perl(Devel::Hide) >= 0.0007
BuildRequires:	perl(File::Glob)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(IPC::Open2)
BuildRequires:	perl(Module::Metadata)
BuildRequires:	perl(Test::More)
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
# Author/Release tests
%if 0%{!?perl_bootstrap:1} && ! %{xsonly}
BuildRequires:	perl(blib)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist)
BuildRequires:	perl(Test::CPAN::Changes)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
%if ! %{old_tk}
BuildRequires:	perl(Test::Kwalitee) >= 1.21
%endif
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling), hunspell-en
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
This module allows you to execute code when Perl has finished compiling the
surrounding scope.

%prep
%setup -q -n B-Hooks-EndOfScope-%{version}

# Need to tweak the test suite if we have Test::More < 0.88
%if %{old_test_more}
%patch1
rm xt/author/kwalitee.t
%endif

# Filter pure-perl requires/provides where we can only support the XS version
%if %{xsonly}
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Ev '^perl[(](base|constant|Hash::Util::FieldHash|Scalar::Util|Tie::Hash)[)]'"
%global __perl_requires %{reqfilt}
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Ev '^perl[(]B::Hooks::EndOfScope::PP[)]'"
%global __perl_provides %{provfilt}
%endif

# British-English spelling LICENCE upsets US spell checker
echo LICENCE >> xt/author/pod-spell.t

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
# AUTHOR_TESTING and extra tests explicitly test pure-perl version
%if ! %{xsonly}
export AUTHOR_TESTING=1
%endif
make test
%if 0%{!?perl_bootstrap:1} && ! %{xsonly}
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"
%endif

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENCE
%else
%doc LICENCE
%endif
%doc Changes CONTRIBUTING README
%{perl_vendorlib}/B/
%{_mandir}/man3/B::Hooks::EndOfScope.3*
%{_mandir}/man3/B::Hooks::EndOfScope::PP.3*
%{_mandir}/man3/B::Hooks::EndOfScope::XS.3*

%changelog
* Tue Jan 10 2017 Paul Howarth <paul@city-fan.org> - 0.21-2
- Test::Kwalitee ≥ 1.21 now available back to Fedora 9
- Fix FTBFS when perl is not in the minimal buildroot

* Thu May 26 2016 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Work with Object::Remote by removing require() call on Tie::StdHash in PP
- Update patch for building with old Test::More versions

* Sat May  7 2016 Paul Howarth <paul@city-fan.org> - 0.20-1
- Update to 0.20
  - Remove unnecessary and erroneous extra crud in inc/

* Tue May  3 2016 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19
  - More Makefile.PL updates
  - Makefile.PL now checks for a working compiler using ExtUtils::HasCompiler
    (inlined into the build) rather than ExtUtils::CBuilder (CPAN RT#113685)
- Remove bundled dependencies of ExtUtils::HasCompiler, which break builds on
  older distributions
- Simplify find command using -delete
- Update patch for building with old Test::More versions
- Prefer %%global over %%define

* Thu Jun 25 2015 Paul Howarth <paul@city-fan.org> - 0.15-4
- Perl 5.22 rebuild

* Fri May 15 2015 Paul Howarth <paul@city-fan.org> - 0.15-1
- Update to 0.15
  - Updated the tooling for generating Makefile.PL
  - Removed Tie::StdHash from prereqs, which is not require()able as a module
    on its own, despite being indexed (GH #3)
  - Fixed the addition in release 0.14 of Hash::Util::FieldHash as a
    prerequisite (which is not available prior to perl 5.010) for pure-perl
    installations (CPAN RT#104435)
- Update patch for building with old Test::More versions

* Sun Feb  1 2015 Paul Howarth <paul@city-fan.org> - 0.14-1
- Update to 0.14
  - Line numbers in shipped code are now the same as the repository source, for
    easier debugging
  - More accurate dynamic prereq declarations
- Update patch for building with old Test::More versions

* Thu Sep 11 2014 Paul Howarth <paul@city-fan.org> - 0.13-4
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible
- BR: perl(Test::CPAN::Changes) unconditionally

* Wed Jan  8 2014 Paul Howarth <paul@city-fan.org> - 0.13-1
- Update to 0.13
  - Variable::Magic added as a runtime recommendation for greater visibility
    (CPAN RT#89245)
  - Fixed broken logic in compiler detection on older perls
  - Fixed inaccurate repository metadata
- This release by ETHER -> update source URL
- Drop Pod Coverage patch, no longer needed
- Update patch for building with old Test::More versions
- Don't run the release tests when bootstrapping

* Wed Dec  5 2012 Paul Howarth <paul@city-fan.org> - 0.12-1
- Update to 0.12
  - Complete pure-perl implementation in addition to the one based on
    Variable::Magic; you can specify the implementation explicitly by use-ing
    B::Hooks::EndOfScope::PP or B::Hooks::EndOfScope::XS, or by setting
    $ENV{B_HOOKS_ENDOFSCOPE_IMPLEMENTATION} to either 'XS' or 'PP'
  - Switch from using Sub::Exporter to the more conservative
    Sub::Exporter::Progressive
- Drop patch for building with old ExtUtils::MakeMaker versions, no longer
  needed
- Update patch for building with old Test::More versions
- Add new patch to fix POD coverage issues in new pure-perl implementation
- Build only the XS implementation if we don't have perl ≥ 5.10
- Only run the release tests if we've built both implementations, as the POD
  coverage test will die otherwise
- Classify buildreqs by usage
- This release by BOBTFISH -> update source URL
- BR: perl(ExtUtils::CBuilder) ≥ 0.26, perl(Devel::Hide) ≥ 0.0007,
  perl(Module::Implementation) ≥ 0.05 and perl(Module::Runtime) ≥ 0.012
- BR: perl(Sub::Exporter::Progressive) rather than perl(Sub::Exporter)
- BR: perl(base), perl(constant), perl(Hash::Util::FieldHash) and
  perl(Scalar::Util) if we're building the pure-perl implementation
- Filter requires/provides for unsupported implementations
- Add runtime dependencies for Module::Implementation and Module::Runtime

* Thu Jul 12 2012 Paul Howarth <paul@city-fan.org> - 0.11-2
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Feb 23 2012 Paul Howarth <paul@city-fan.org> - 0.11-1
- Update to 0.11 (a minor efficiency improvement)
- Bump perl(Variable::Magic) version requirement to 0.48

* Thu Feb 16 2012 Paul Howarth <paul@city-fan.org> - 0.10-1
- Update to 0.10 (stop propagating our magic through localisation)
- Package LICENSE file
- Update patch for building with old ExtUtils::MakeMaker versions
- Add patch to support building with Test::More < 0.89
- BR: perl(Test::EOL) and perl(Test::NoTabs) for additional test coverage

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.09-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Apr 29 2011 Paul Howarth <paul@city-fan.org> - 0.09-1
- Import from Fedora
- Update to 0.09 (improve distribution metadata)

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 15 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.08-5
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu Apr 29 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.08-4
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.08-3
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sun May 17 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.08-1
- Auto-update to 0.08 (by cpan-spec-update 0.01)
- Altered br on perl(ExtUtils::MakeMaker) (0 => 6.42)
- Altered br on perl(Variable::Magic) (0.31 => 0.34)

* Sun Mar 08 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.07-1
- Update to 0.07

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.04-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Nov 08 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-1
- Update for submission

* Sat Nov 08 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.04-0.1
- Initial RPM packaging
- Generated with cpan2dist (CPANPLUS::Dist::RPM version 0.0.5)
